unit tietokantatesti;
(*  Esimerkki erilaisten tietokantayhteyden muodostamisesta ja
    komponenttien ksittelyst. Ks. mys Diagram-vlilehti.
    MN, 3.4.2004.

  Kytettvt tietokannat:
   1. Paikallinen Access-kanta TESTIKANTA, taulu Testitaulu
   2. Paikallinen Paradox-kanta, taulu paratest.db
      yhteys ADO-tekniikalla, OleDB-ajurilla.
      (luotu database desktop -ohjelman avulla)
   3. Hajautettu Interbase-kanta, taulu henkil.
      (kyttjtunnus TEST, salasana test)
      (kanta sijaitsee fyysisesti samalla koneella, luotu interbasen
      IBconsole-ohjelmalla ja editoitu database desktopilla)

  Tietokantayhteydet:
   1. BDE:n natiiviajurilla Paradox-kantaan (hakemistojen mrityksess
      kytetty TSession-komponenttia)
   2. BDE:ll ja ODBC-linkill Access-kantaan
   3. BDE:n natiiviajurilla (ks. BDE Administrator) InterBase-kantaan
   4. ADO:n OleDB-ODBC -yhteydell Paradox-kantaan
   5. ADO:n OleDB-Access -yhteydell Access-kantaan
   6. dbExpress (SQLQuery) ja ClientDataSet Interbase-kantaan.
      kanta sijaitsee fyysisesti samalla koneella,
      mutta voitaisiin hajauttaa ilman muutoksia koodiin
      (ks. IBConsole).

   Mys accessiin voi avata ODBC-yhteyksi, jolloin esim. paradox-
   kantojen editointi onnistuu.

   Ilman ClientDataSetia dbExpress-kyselyn (SQLQuery)
   tuloksia ei voisi nytt ruudustossa (dbExpress-
   tietojoukkoa ei voi kelata taaksepin). SQLQuery
   soveltuu kuitenkin WWW-sivuille ja komponeteille,
   jotka eivt ole 'data-aktiivisia'

   Ongelmia: jossain muistivuoto? Muutaman ajokerran jlkeen
   'insufficent memory'

   Jostain syyst access-kannan ruudustonkym ei pivity oikein
   kyttjn tehdess muutoksia BDE-yhteydell.
     => Ellei ole erityist syyt muuhun, kannattaa harkkatyss
        kytt ADO:a ja Accessia.                                         *)
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ADODB, DB, Grids, DBGrids, DBTables, StdCtrls, ExtCtrls, DBCtrls,
  DBXpress, FMTBcd, DBClient, Provider, SqlExpr, Mask;

type
  TFormDB = class(TForm)
    BdeQuery: TQuery;
    DataSource: TDataSource;
    DBGrid1: TDBGrid;
    AdoConnection: TADOConnection;
    AdoQuery: TADOQuery;
    DBNavigator1: TDBNavigator;
    SqlConnection: TSQLConnection;
    SqlQuery: TSQLQuery;
    DataSetProvider1: TDataSetProvider;
    ClientDataSet: TClientDataSet;
    DataSourceSQL: TDataSource;
    BdeIbQuery: TQuery;
    BdeConnection: TDatabase;
    Session1: TSession;
    BdeAccessConnection: TDatabase;
    BdeAccessQuery: TQuery;
    ADOParadoxConnection: TADOConnection;
    ADOParadoxQuery: TADOQuery;
    Panel1: TPanel;
    ButtonExec: TButton;
    ButtonUpdate: TButton;
    DBEdit1: TDBEdit;
    ButtonNext: TButton;
    ButtonFirst: TButton;
    ComboBox1: TComboBox;
    MemoSQL: TMemo;
    procedure ComboBox1Change(Sender: TObject);
    procedure ButtonExecClick(Sender: TObject);
    procedure ButtonUpdateClick(Sender: TObject);
    procedure ButtonNextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SqlConnectionBeforeConnect(Sender: TObject);
    procedure BdeConnectionLogin(Database: TDatabase;
      LoginParams: TStrings);
    procedure ButtonFirstClick(Sender: TObject);
  private
    CurrentDataSet:TDataSet;
    SQL:TStrings;
    DataSets:TStringList;
    procedure GetCurrentSQL;
    procedure SetCurrentSQL;
    procedure EnableButtons(buttons:array of TButton;b:boolean);
    function Truncate(lo,hi,current:Integer): Integer;
    procedure AdjustConnections;
  public
  end;

var FormDB:TFormDB;

implementation

{$R *.dfm}

function TFormDB.Truncate(lo, hi, current: Integer): Integer;
begin
  if current<lo then current:=lo
  else if current>hi then current:=hi;
  Result:=current;
end;

// Demonstroidaan Delphin taulukkojen kytt
// Oikeastaan kannattaisi tehd ActionListilla, ksitelln myhemmin...
procedure TFormDB.EnableButtons(buttons: array of TButton; b: boolean);
var i:integer;
begin
  for i:=low(buttons) to high(buttons) do buttons[i].Enabled:=b;
end;


procedure TFormDB.AdjustConnections;
var oldset,newset:TDataSet;b:boolean;
begin
  ComboBox1.ItemIndex:=Truncate(0,datasets.Count-1,ComboBox1.ItemIndex);
  oldset:=DataSource.DataSet;
  newset:= DataSets.Objects[ComboBox1.ItemIndex] as TDataSet;
  if (oldset<>newset) then oldset.Active:=false;

  if (newset.Active=false) then newset.Active:=true;
  DataSource.DataSet:=newset;

  b:=newset is TClientDataSet;
  if b then CurrentDataSet:=SQLQuery else CurrentDataSet:=newset;

  // delphissa taulukoita voi antaa suoraan funktion argumenteiksi
  // huom. oikeasti tt ei kannata tehd nin, koska taulukko luodaan
  // jokaisella kutsukerralla...
  enableButtons([ButtonUpdate, ButtonNext, ButtonFirst],b);
  SqlQuery.Active:=b;
  // when clientdataset is activated, SqlQuery is somehow deactivated

  GetCurrentSQL; // haetaan nykyisen Query-komponentin SQL-viite
end;


procedure TFormDB.GetCurrentSQL;
var s:TStrings;d:TDataSet;
begin
  d:=CurrentDataSet;
  // haetaan viite SQL-propertyyn
  if (d is TAdoQuery) then SQL:=(d as TAdoQuery).SQL
  else if (d is TQuery) then SQL:=(d as TQuery).SQL
  else if (d is TSQLQuery) then SQL:=(d as TSQLQuery).SQL;

  // memosql kopioi sql:n kohteen sislln, ei viitett!
  MemoSQL.Lines:=SQL;
end;

procedure TFormDB.SetCurrentSQL;
begin
  CurrentDataSet.Active:=false;
  // sijoitetaan tmnhetkisen Query-komponentin SQL-lauseeksi
  SQL.Assign(MemoSQL.Lines);
  CurrentDataSet.Active:=true;
end;



procedure TFormDB.ComboBox1Change(Sender: TObject);
begin
  AdjustConnections;
end;

procedure TFormDB.ButtonExecClick(Sender: TObject);
begin
  SetCurrentSQL;
end;

procedure TFormDB.ButtonUpdateClick(Sender: TObject);
begin
  ClientDataSet.ApplyUpdates(1);
end;

procedure TFormDB.FormCreate(Sender: TObject);
begin
  // dataset-oliot stringlistassa
  datasets := TStringList.Create;
  datasets.AddObject('BDE + Paradox',BdeQuery);
  datasets.AddObject('BDE + ODBC + Access',BdeAccessQuery);
  datasets.AddObject('BDE + InterBase',BdeIbQuery);
  datasets.AddObject('ADO + ODBC + Paradox',AdoParadoxQuery);
  datasets.AddObject('ADO + Access',AdoQuery);
  datasets.AddObject('dbExpress + ClientDataSet + InterBase',ClientDataSet);

  Combobox1.Items:=datasets; //comboboxin setitems kutsuu assign-metodia
  Combobox1.ItemIndex:=0;
end;


procedure TFormDB.FormShow(Sender: TObject);
begin
  AdjustConnections;
end;

procedure TFormDB.FormDestroy(Sender: TObject);
begin
  datasets.Free;
end;


procedure TFormDB.SqlConnectionBeforeConnect(Sender: TObject);
begin
  with SQLConnection do if LoginPrompt = False then begin
    Params.Values['User_Name'] := 'TEST';
    Params.Values['Password'] := 'test';
  end;
end;

procedure TFormDB.BdeConnectionLogin(Database: TDatabase;
  LoginParams: TStrings);
begin
  LoginParams.Values['USER NAME'] := 'TEST';
  LoginParams.Values['PASSWORD'] := 'test';
end;

procedure TFormDB.ButtonFirstClick(Sender: TObject);
begin
  SQLQuery.First;
end;

procedure TFormDB.ButtonNextClick(Sender: TObject);
begin
  SQLQuery.Next;
end;



end.
